<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistanceReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfDistanceReportItem extends AbstractStructArrayBase
{
    /**
     * The DistanceReportItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DistanceReportItem[]
     */
    public $DistanceReportItem;
    /**
     * Constructor method for ArrayOfDistanceReportItem
     * @uses ArrayOfDistanceReportItem::setDistanceReportItem()
     * @param \StructType\DistanceReportItem[] $distanceReportItem
     */
    public function __construct(array $distanceReportItem = array())
    {
        $this
            ->setDistanceReportItem($distanceReportItem);
    }
    /**
     * Get DistanceReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DistanceReportItem[]|null
     */
    public function getDistanceReportItem()
    {
        return isset($this->DistanceReportItem) ? $this->DistanceReportItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDistanceReportItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDistanceReportItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDistanceReportItemForArrayConstraintsFromSetDistanceReportItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDistanceReportItemDistanceReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfDistanceReportItemDistanceReportItemItem instanceof \StructType\DistanceReportItem) {
                $invalidValues[] = is_object($arrayOfDistanceReportItemDistanceReportItemItem) ? get_class($arrayOfDistanceReportItemDistanceReportItemItem) : sprintf('%s(%s)', gettype($arrayOfDistanceReportItemDistanceReportItemItem), var_export($arrayOfDistanceReportItemDistanceReportItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DistanceReportItem property can only contain items of type \StructType\DistanceReportItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DistanceReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem[] $distanceReportItem
     * @return \ArrayType\ArrayOfDistanceReportItem
     */
    public function setDistanceReportItem(array $distanceReportItem = array())
    {
        // validation for constraint: array
        if ('' !== ($distanceReportItemArrayErrorMessage = self::validateDistanceReportItemForArrayConstraintsFromSetDistanceReportItem($distanceReportItem))) {
            throw new \InvalidArgumentException($distanceReportItemArrayErrorMessage, __LINE__);
        }
        if (is_null($distanceReportItem) || (is_array($distanceReportItem) && empty($distanceReportItem))) {
            unset($this->DistanceReportItem);
        } else {
            $this->DistanceReportItem = $distanceReportItem;
        }
        return $this;
    }
    /**
     * Add item to DistanceReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\DistanceReportItem $item
     * @return \ArrayType\ArrayOfDistanceReportItem
     */
    public function addToDistanceReportItem(\StructType\DistanceReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DistanceReportItem) {
            throw new \InvalidArgumentException(sprintf('The DistanceReportItem property can only contain items of type \StructType\DistanceReportItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DistanceReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DistanceReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DistanceReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DistanceReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DistanceReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DistanceReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistanceReportItem
     */
    public function getAttributeName()
    {
        return 'DistanceReportItem';
    }
}
